Subject: Re: [PATCH] ci: avoid unnecessary builds

From: Derrick Stolee <[email-masked]>
Date: Mon, 7 Nov 2022 15:08:46 -0500

On 11/7/22 2:53 PM, Taylor Blau wrote:
> On Mon, Nov 07, 2022 at 02:45:24PM -0500, Derrick Stolee wrote:
>> On 11/3/22 9:34 AM, Johannes Schindelin via GitGitGadget wrote:
>>> From: Johannes Schindelin <[email-masked]>
>>>
>>> Whenever a branch is pushed to a repository which has GitHub Actions
>>> enabled, a bunch of new workflow runs are started.
>>>
>>> We sometimes see contributors push multiple branch updates in rapid
>>> succession, which in conjunction with the impressive time swallowed by
>>> even just a single CI build frequently leads to many queued-up runs.
>>>
>>> This is particularly problematic in the case of Pull Requests where a
>>> single contributor can easily (inadvertently) prevent timely builds for
>>> other contributors.
>>
>> As someone who is both the cause and the victim of this, I
>> thank you for finding a way to reduce wasted CPU time. This
>> patch looks good to me, though I'll need to trust the docs
>> and your testing to be sure it will work. We will definitely
>> see it in place as it merges into 'next' and 'main'.
> 
> I wonder how we should treat Ævar's concerns in this thread. I suspect
> that the vast majority of workflows wouldn't be affected, but I don't
> want to completely break Ævar's workflow, either ;-).
> 
> Some kind of configuration mechanism like I proposed might be nice.
> Thoughts?

Taking a look at that sub-thread, I have two thoughts:

1. I don't think supporting a "multiple pushes of WIP work"
   scenario is a good use of "free" resources. If you want to
   test multiple versions of something, then use multiple
   branches (and I think Johannes's patch allows concurrent
   builds for distinct branch names).

2. The change you recommend requires running the job and
   deciding at runtime whether to do the actual build
   (unless I'm mistaken). It is better to let the workflow
   coordinator decide on concurrency before the stage where
   worker VMs are engaged.

Either of these points may have an incorrect assumption, so
I'm prepared to be wrong.

Thanks,
-Stolee